package cz.fi.muni.mapper;

import cz.fi.muni.api.requestDto.IngredientRequestDto;
import cz.fi.muni.api.responseDto.IngredientResponseDto;

import cz.fi.muni.data.model.Ingredient;
import org.mapstruct.Mapper;
import org.mapstruct.ReportingPolicy;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
@Mapper(unmappedSourcePolicy = ReportingPolicy.IGNORE,
        unmappedTargetPolicy = ReportingPolicy.IGNORE,
        componentModel = "spring")
public interface IngredientMapper {

    Ingredient toEntity(IngredientRequestDto requestDto);

    IngredientResponseDto toResponseDto(Ingredient ingredient);

    List<IngredientResponseDto> toResponseDtoList(List<Ingredient> ingredients);

}
